## visad
Interface Data

All Superinterfaces:
  Thing

All Known Subinterfaces:
  EarthLocation, Field, FlatFieldIface, Function, Gridded1DSetIface, GriddedSetIface, ImageSequence, LatLonPoint, NamedLocation, NavigatedField, RealIface, RealTupleIface, RemoteClientData, RemoteClientField, RemoteClientPartitionedField, RemoteClientTuple, RemoteClusterData, RemoteData, RemoteField, RemoteFlatField, RemoteFunction, RemoteNodeData, RemoteNodeField, RemoteNodePartitionedField, RemoteNodeTuple, RemoteTupleIface, SampledSetIface, SatelliteData, ScalarIface, SetIface, SimpleSetIface, SingleBandedImage, TupleIface

All Known Implementing Classes:
  DataImpl, EarthLocationTuple, FieldImpl, FlatField, FunctionImpl, Gridded1DSet, GriddedSet, ImageSequenceImpl, LatLonTuple, NamedLocationTuple, NavigatedImage, Real, RealTuple, RemoteClientDataImpl, RemoteClientFieldImpl, RemoteClientPartitionedFieldImpl, RemoteClientTupleImpl, RemoteClusterDataImpl, RemoteDataImpl, RemoteFieldImpl, RemoteFlatFieldImpl, RemoteFunctionImpl, RemoteNodeDataImpl, RemoteNodeFieldImpl, RemoteNodePartitionedFieldImpl, RemoteNodeTupleImpl, SampledSet, SatelliteImage, Scalar, Set, SimpleSet, SingleBandedImageImpl, Tuple

public interface Data
extends Thing

Data is the top-level interface of the VisAD data hierarchy. See the DataImpl class for more information.

Field Summary
`static int` `ABS` constants for various unary arithmetic operations
`static int` `ACOS`
`static int` `ACOS_DEGREES`
`static int` `ADD` constants for various binary arithmetic operations
`static int` `ASIN`
`static int` `ASIN_DEGREES`
`static int` `ATAN`
`static int` `ATAN_DEGREES`
`static int` `ATAN2`
`static int` `ATAN2_DEGREES`
`static int` `CEIL`
`static int` `COS`
`static int` `COS_DEGREES`
`static double` `DEGREES_TO_RADIANS`
`static int` `DEPENDENT` DEPENDENT error estimation Mode
`static int` `DIVIDE`
`static int` `EXP`
`static int` `FLOOR`
`static int` `INDEPENDENT` INDEPENDENT error estimation Mode
`static int` `INV_ATAN2`
`static int` `INV_ATAN2_DEGREES`
`static int` `INV_DIVIDE`
`static int` `INV_POW`
`static int` `INV_REMAINDER`
`static int` `INV_SUBTRACT`
`static int` `LOG`
`static int` `MAX`
`static int` `MIN`
`static int` `MULTIPLY`
`static int` `NEAREST_NEIGHBOR` NEAREST_NEIGHBOR resampling mode
`static int` `NEGATE`
`static int` `NO_ERRORS` NO_ERRORS error estimation Mode
`static int` `NOP`
`static int` `POW`
`static double` `RADIANS_TO_DEGREES` constants for angle Unit conversions
`static int` `REMAINDER`
`static int` `RINT`
`static int` `ROUND`
`static int` `SIN`
`static int` `SIN_DEGREES`
`static int` `SQRT`
`static int` `SUBTRACT`
`static int` `TAN`
`static int` `TAN_DEGREES`
`static int` `WEIGHTED_AVERAGE` WEIGHTED_AVERAGE resampling Mode

Method Summary
`Data` `abs()` call unary() to take the absolute value of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `abs(int sampling_mode, int error_mode)` call unary() to take the absolute value of this
`Data` `acos()` call unary() to take the arccos of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `acos(int sampling_mode, int error_mode)` call unary() to take the arccos of this producing radian Units
`Data` `acosDegrees()` call unary() to take the arccos of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `acosDegrees(int sampling_mode, int error_mode)` call unary() to take the arccos of this producing degree Units
`Data` `add(Data data)` call binary() to add data to this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `add(Data data, int sampling_mode, int error_mode)` call binary() to add data to this
`Data` `adjustSamplingError(Data error, int error_mode)` return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode
`Data` `asin()` call unary() to take the arcsin of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `asin(int sampling_mode, int error_mode)` call unary() to take the arcsin of this producing radian Units
`Data` `asinDegrees()` call unary() to take the arcsin of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `asinDegrees(int sampling_mode, int error_mode)` call unary() to take the arcsin of this producing degree Units
`Data` `atan()` call unary() to take the arctan of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atan(int sampling_mode, int error_mode)` call unary() to take the arctan of this producing radian Units
`Data` `atan2(Data data)` call binary() to take the atan of this by data producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atan2(Data data, int sampling_mode, int error_mode)` call binary() to take the atan of this by data producing radian Units
`Data` `atan2Degrees(Data data)` call binary() to take the atan of this by data producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atan2Degrees(Data data, int sampling_mode, int error_mode)` call binary() to take the atan of this by data producing degree Units
`Data` `atanDegrees()` call unary() to take the arctan of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atanDegrees(int sampling_mode, int error_mode)` call unary() to take the arctan of this producing degree Units
`Data` `binary(Data data, int op, int sampling_mode, int error_mode)` Pointwise binary operation between this and data.
`Data` `binary(Data data, int op, MathType new_type, int sampling_mode, int error_mode)` Pointwise binary operation between this and data.
`Data` `ceil()` call unary() to take the ceiling of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `ceil(int sampling_mode, int error_mode)` call unary() to take the ceiling of this
`Data` `changeMathType(MathType new_type)` call unary() to clone this except with a new MathType
`double[][]` `computeRanges(RealType[] reals)` compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D
`DataShadow` `computeRanges(ShadowType type, DataShadow shadow)` Recursive version of computeRanges(), called down through Data object tree.
`DataShadow` `computeRanges(ShadowType type, int n)` Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector.
`Data` `cos()` call unary() to take the cos of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `cos(int sampling_mode, int error_mode)` call unary() to take the cos of this assuming radian Units unless this actual Units are degrees
`Data` `cosDegrees()` call unary() to take the cos of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `cosDegrees(int sampling_mode, int error_mode)` call unary() to take the cos of this assuming degree Units unless this actual Units are radians
`Object` `dataClone()` A VisAD adaptation of clone that works for local or remote Data.
`Data` `divide(Data data)` call binary() to divide this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `divide(Data data, int sampling_mode, int error_mode)` call binary() to divide this by data
`Data` `exp()` call unary() to take the exponent of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `exp(int sampling_mode, int error_mode)` call unary() to take the exponent of this
`Data` `floor()` call unary() to take the floor of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `floor(int sampling_mode, int error_mode)` call unary() to take the floor of this
`MathType` `getType()`
`boolean` `isMissing()`
`DataImpl` `local()`
`Data` `log()` call unary() to take the log of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `log(int sampling_mode, int error_mode)` call unary() to take the log of this
`String` `longString()`
`String` `longString(String pre)`
`Data` `max(Data data)` call binary() to take the max of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `max(Data data, int sampling_mode, int error_mode)` call binary() to take the max of this and data
`Data` `min(Data data)` call binary() to take the min of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `min(Data data, int sampling_mode, int error_mode)` call binary() to take the min of this and data
`Data` `multiply(Data data)` call binary() to multiply this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `multiply(Data data, int sampling_mode, int error_mode)` call binary() to multiply this by data
`Data` `negate()` call unary() to negate this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `negate(int sampling_mode, int error_mode)` call unary() to negate this
`Data` `pow(Data data)` call binary() to raise this to data power, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `pow(Data data, int sampling_mode, int error_mode)` call binary() to raise this to data power
`Data` `remainder(Data data)` call binary() to take the remainder of this divided by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `remainder(Data data, int sampling_mode, int error_mode)` call binary() to take the remainder of this divided by data
`Data` `rint()` call unary() to take the rint (essentially round) of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `rint(int sampling_mode, int error_mode)` call unary() to take the rint (essentially round) of this
`Data` `round()` call unary() to take the round of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `round(int sampling_mode, int error_mode)` call unary() to take the round of this
`Data` `sin()` call unary() to take the sin of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `sin(int sampling_mode, int error_mode)` call unary() to take the sin of this assuming radian Units unless this actual Units are degrees
`Data` `sinDegrees()` call unary() to take the sin of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `sinDegrees(int sampling_mode, int error_mode)` call unary() to take the sin of this assuming degree Units unless this actual Units are radians
`Data` `sqrt()` call unary() to take the square root of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `sqrt(int sampling_mode, int error_mode)` call unary() to take the square root of this
`Data` `subtract(Data data)` call binary() to subtract data from this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `subtract(Data data, int sampling_mode, int error_mode)` call binary() to subtract data from this
`Data` `tan()` call unary() to take the tan of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `tan(int sampling_mode, int error_mode)` call unary() to take the tan of this assuming radian Units unless this actual Units are degrees
`Data` `tanDegrees()` call unary() to take the tan of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `tanDegrees(int sampling_mode, int error_mode)` call unary() to take the tan of this assuming degree Units unless this actual Units are radians
`Data` `unary(int op, int sampling_mode, int error_mode)` Pointwise unary operation applied to this.
`Data` `unary(int op, MathType new_type, int sampling_mode, int error_mode)` Pointwise unary operation applied to this.

Methods inherited from interface visad.Thing
`addReference, removeReference`

Field Detail

### NEAREST_NEIGHBOR

    public static final int NEAREST_NEIGHBOR

  NEAREST_NEIGHBOR resampling mode

  See Also:
    Constant Field Values

### WEIGHTED_AVERAGE

    public static final int WEIGHTED_AVERAGE

  WEIGHTED_AVERAGE resampling Mode

  See Also:
    Constant Field Values

### INDEPENDENT

    public static final int INDEPENDENT

  INDEPENDENT error estimation Mode

  See Also:
    Constant Field Values

### DEPENDENT

    public static final int DEPENDENT

  DEPENDENT error estimation Mode

  See Also:
    Constant Field Values

### NO_ERRORS

    public static final int NO_ERRORS

  NO_ERRORS error estimation Mode

  See Also:
    Constant Field Values

### ADD

    public static final int ADD

  constants for various binary arithmetic operations

  See Also:
    Constant Field Values

### SUBTRACT

    public static final int SUBTRACT

See Also:
  Constant Field Values

### INV_SUBTRACT

    public static final int INV_SUBTRACT

See Also:
  Constant Field Values

### MULTIPLY

    public static final int MULTIPLY

See Also:
  Constant Field Values

### DIVIDE

    public static final int DIVIDE

See Also:
  Constant Field Values

### INV_DIVIDE

    public static final int INV_DIVIDE

See Also:
  Constant Field Values

### POW

    public static final int POW

See Also:
  Constant Field Values

### INV_POW

    public static final int INV_POW

See Also:
  Constant Field Values

### MAX

    public static final int MAX

See Also:
  Constant Field Values

### MIN

    public static final int MIN

See Also:
  Constant Field Values

### ATAN2

    public static final int ATAN2

See Also:
  Constant Field Values

### ATAN2_DEGREES

    public static final int ATAN2_DEGREES

See Also:
  Constant Field Values

### INV_ATAN2

    public static final int INV_ATAN2

See Also:
  Constant Field Values

### INV_ATAN2_DEGREES

    public static final int INV_ATAN2_DEGREES

See Also:
  Constant Field Values

### REMAINDER

    public static final int REMAINDER

See Also:
  Constant Field Values

### INV_REMAINDER

    public static final int INV_REMAINDER

See Also:
  Constant Field Values

### ABS

    public static final int ABS

  constants for various unary arithmetic operations

  See Also:
    Constant Field Values

### ACOS

    public static final int ACOS

See Also:
  Constant Field Values

### ACOS_DEGREES

    public static final int ACOS_DEGREES

See Also:
  Constant Field Values

### ASIN

    public static final int ASIN

See Also:
  Constant Field Values

### ASIN_DEGREES

    public static final int ASIN_DEGREES

See Also:
  Constant Field Values

### ATAN

    public static final int ATAN

See Also:
  Constant Field Values

### ATAN_DEGREES

    public static final int ATAN_DEGREES

See Also:
  Constant Field Values

### CEIL

    public static final int CEIL

See Also:
  Constant Field Values

### COS

    public static final int COS

See Also:
  Constant Field Values

### COS_DEGREES

    public static final int COS_DEGREES

See Also:
  Constant Field Values

### EXP

    public static final int EXP

See Also:
  Constant Field Values

### FLOOR

    public static final int FLOOR

See Also:
  Constant Field Values

### LOG

    public static final int LOG

See Also:
  Constant Field Values

### RINT

    public static final int RINT

See Also:
  Constant Field Values

### ROUND

    public static final int ROUND

See Also:
  Constant Field Values

### SIN

    public static final int SIN

See Also:
  Constant Field Values

### SIN_DEGREES

    public static final int SIN_DEGREES

See Also:
  Constant Field Values

### SQRT

    public static final int SQRT

See Also:
  Constant Field Values

### TAN

    public static final int TAN

See Also:
  Constant Field Values

### TAN_DEGREES

    public static final int TAN_DEGREES

See Also:
  Constant Field Values

### NEGATE

    public static final int NEGATE

See Also:
  Constant Field Values

### NOP

    public static final int NOP

See Also:
  Constant Field Values

### RADIANS_TO_DEGREES

    public static final double RADIANS_TO_DEGREES

  constants for angle Unit conversions

  See Also:
    Constant Field Values

### DEGREES_TO_RADIANS

    public static final double DEGREES_TO_RADIANS

See Also:
  Constant Field Values

Method Detail

### local

    public DataImpl local()
                   throws VisADException,
                          RemoteException

  Returns:
    a local copy if remote (i.e., this is RemoteData), else return this if local (i.e., this is DataImpl)
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### getType

    public MathType getType()
                     throws VisADException,
                            RemoteException

  Returns:
    MathType of this Data
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### isMissing

    public boolean isMissing()
                      throws VisADException,
                             RemoteException

  Returns:
    flag indicating whether this Data has a missing value
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### binary

    public Data binary(Data data,
                       int op,
                       int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  Pointwise binary operation between this and data. Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains or Sets (regarded as domains of Fields wthout ranges). Data.ADD is only op defined for Text, interpreted as concatenate. MathTypes of this and data must match, or one may match the range of the other if it is a FunctionType.

  Parameters:
    `data` - other Data operand for binary operation
    `op` - may be Data.ADD, Data.SUBTRACT, etc; these include all binary operations defined for Java primitive data types
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation, which takes the MathType of this unless the default Units of that MathType conflict with Units of the result, in which case a generic MathType with appropriate Units is constructed
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### binary

    public Data binary(Data data,
                       int op,
                       MathType new_type,
                       int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  Pointwise binary operation between this and data. Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains or Sets (regarded as domains of Fields wthout ranges). Data.ADD is only op defined for Text, interpreted as concatenate. MathTypes of this and data must match, or one may match the range of the other if it is a FunctionType.

  Parameters:
    `data` - other Data operand for binary operation
    `op` - may be Data.ADD, Data.SUBTRACT, etc; these include all binary operations defined for Java primitive data types
    `new_type` - MathType of the result
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result, with MathType = new_type
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### add

    public Data add(Data data)
             throws VisADException,
                    RemoteException

  call binary() to add data to this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### subtract

    public Data subtract(Data data)
                  throws VisADException,
                         RemoteException

  call binary() to subtract data from this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### multiply

    public Data multiply(Data data)
                  throws VisADException,
                         RemoteException

  call binary() to multiply this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### divide

    public Data divide(Data data)
                throws VisADException,
                       RemoteException

  call binary() to divide this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### pow

    public Data pow(Data data)
             throws VisADException,
                    RemoteException

  call binary() to raise this to data power, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### max

    public Data max(Data data)
             throws VisADException,
                    RemoteException

  call binary() to take the max of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### min

    public Data min(Data data)
             throws VisADException,
                    RemoteException

  call binary() to take the min of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2

    public Data atan2(Data data)
               throws VisADException,
                      RemoteException

  call binary() to take the atan of this by data producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2Degrees

    public Data atan2Degrees(Data data)
                      throws VisADException,
                             RemoteException

  call binary() to take the atan of this by data producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### remainder

    public Data remainder(Data data)
                   throws VisADException,
                          RemoteException

  call binary() to take the remainder of this divided by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### add

    public Data add(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to add data to this

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### subtract

    public Data subtract(Data data,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  call binary() to subtract data from this

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### multiply

    public Data multiply(Data data,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  call binary() to multiply this by data

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### divide

    public Data divide(Data data,
                       int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  call binary() to divide this by data

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### pow

    public Data pow(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to raise this to data power

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### max

    public Data max(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to take the max of this and data

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### min

    public Data min(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to take the min of this and data

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2

    public Data atan2(Data data,
                      int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  call binary() to take the atan of this by data producing radian Units

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2Degrees

    public Data atan2Degrees(Data data,
                             int sampling_mode,
                             int error_mode)
                      throws VisADException,
                             RemoteException

  call binary() to take the atan of this by data producing degree Units

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### remainder

    public Data remainder(Data data,
                          int sampling_mode,
                          int error_mode)
                   throws VisADException,
                          RemoteException

  call binary() to take the remainder of this divided by data

  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### unary

    public Data unary(int op,
                      int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  Pointwise unary operation applied to this. Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains, Sets (regarded as domains of Fields wthout ranges) or Text.

  Parameters:
    `op` - may be Data.ABS, Data.ACOS, etc; these include all unary operations defined for Java primitive data types
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation, which takes the MathType of this unless the default Units of that MathType conflict with Units of the result, in which case a generic MathType with appropriate Units is constructed
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### unary

    public Data unary(int op,
                      MathType new_type,
                      int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  Pointwise unary operation applied to this. Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains, Sets (regarded as domains of Fields wthout ranges) or Text.

  Parameters:
    `op` - may be Data.ABS, Data.ACOS, etc; these include all unary operations defined for Java primitive data types
    `new_type` - MathType of the result
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result, with MathType = new_type
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### changeMathType

    public Data changeMathType(MathType new_type)
                        throws VisADException,
                               RemoteException

  call unary() to clone this except with a new MathType

  Parameters:
    `new_type` - MathType of returned Data object
  Returns:
    clone of this Data object except with new MathType
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### abs

    public Data abs()
             throws VisADException,
                    RemoteException

  call unary() to take the absolute value of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acos

    public Data acos()
              throws VisADException,
                     RemoteException

  call unary() to take the arccos of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acosDegrees

    public Data acosDegrees()
                     throws VisADException,
                            RemoteException

  call unary() to take the arccos of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asin

    public Data asin()
              throws VisADException,
                     RemoteException

  call unary() to take the arcsin of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asinDegrees

    public Data asinDegrees()
                     throws VisADException,
                            RemoteException

  call unary() to take the arcsin of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan

    public Data atan()
              throws VisADException,
                     RemoteException

  call unary() to take the arctan of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atanDegrees

    public Data atanDegrees()
                     throws VisADException,
                            RemoteException

  call unary() to take the arctan of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### ceil

    public Data ceil()
              throws VisADException,
                     RemoteException

  call unary() to take the ceiling of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cos

    public Data cos()
             throws VisADException,
                    RemoteException

  call unary() to take the cos of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cosDegrees

    public Data cosDegrees()
                    throws VisADException,
                           RemoteException

  call unary() to take the cos of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### exp

    public Data exp()
             throws VisADException,
                    RemoteException

  call unary() to take the exponent of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### floor

    public Data floor()
               throws VisADException,
                      RemoteException

  call unary() to take the floor of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### log

    public Data log()
             throws VisADException,
                    RemoteException

  call unary() to take the log of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### rint

    public Data rint()
              throws VisADException,
                     RemoteException

  call unary() to take the rint (essentially round) of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### round

    public Data round()
               throws VisADException,
                      RemoteException

  call unary() to take the round of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sin

    public Data sin()
             throws VisADException,
                    RemoteException

  call unary() to take the sin of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sinDegrees

    public Data sinDegrees()
                    throws VisADException,
                           RemoteException

  call unary() to take the sin of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sqrt

    public Data sqrt()
              throws VisADException,
                     RemoteException

  call unary() to take the square root of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tan

    public Data tan()
             throws VisADException,
                    RemoteException

  call unary() to take the tan of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tanDegrees

    public Data tanDegrees()
                    throws VisADException,
                           RemoteException

  call unary() to take the tan of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### negate

    public Data negate()
                throws VisADException,
                       RemoteException

  call unary() to negate this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### abs

    public Data abs(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the absolute value of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acos

    public Data acos(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the arccos of this producing radian Units

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acosDegrees

    public Data acosDegrees(int sampling_mode,
                            int error_mode)
                     throws VisADException,
                            RemoteException

  call unary() to take the arccos of this producing degree Units

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asin

    public Data asin(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the arcsin of this producing radian Units

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asinDegrees

    public Data asinDegrees(int sampling_mode,
                            int error_mode)
                     throws VisADException,
                            RemoteException

  call unary() to take the arcsin of this producing degree Units

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan

    public Data atan(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the arctan of this producing radian Units

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atanDegrees

    public Data atanDegrees(int sampling_mode,
                            int error_mode)
                     throws VisADException,
                            RemoteException

  call unary() to take the arctan of this producing degree Units

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### ceil

    public Data ceil(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the ceiling of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cos

    public Data cos(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the cos of this assuming radian Units unless this actual Units are degrees

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cosDegrees

    public Data cosDegrees(int sampling_mode,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  call unary() to take the cos of this assuming degree Units unless this actual Units are radians

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### exp

    public Data exp(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the exponent of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### floor

    public Data floor(int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  call unary() to take the floor of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### log

    public Data log(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the log of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### rint

    public Data rint(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the rint (essentially round) of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### round

    public Data round(int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  call unary() to take the round of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sin

    public Data sin(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the sin of this assuming radian Units unless this actual Units are degrees

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sinDegrees

    public Data sinDegrees(int sampling_mode,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  call unary() to take the sin of this assuming degree Units unless this actual Units are radians

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sqrt

    public Data sqrt(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the square root of this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tan

    public Data tan(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the tan of this assuming radian Units unless this actual Units are degrees

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tanDegrees

    public Data tanDegrees(int sampling_mode,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  call unary() to take the tan of this assuming degree Units unless this actual Units are radians

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### negate

    public Data negate(int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  call unary() to negate this

  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public double[][] computeRanges(RealType[] reals)
                             throws VisADException,
                                    RemoteException

  compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D

  Returns:
    double[reals.length][2] giving the low and high value in this for each RealType in reals
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    int n)
                             throws VisADException,
                                    RemoteException

  Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector. Called from DataRenderer with n = DisplayImpl.getScalarCount().

  Parameters:
    `type` - ShadowType generated for MathType of this
    `n` - number of RealTypes in DisplayImpl.RealTypeVector
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    DataShadow shadow)
                             throws VisADException,
                                    RemoteException

  Recursive version of computeRanges(), called down through Data object tree.

  Parameters:
    `type` - ShadowType generated for MathType of this
    `shadow` - DataShadow instance whose contained double[][] array and animation sampling Set are modified according to RealType values in this, and used as return value
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### adjustSamplingError

    public Data adjustSamplingError(Data error,
                                    int error_mode)
                             throws VisADException,
                                    RemoteException

  return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode

  Parameters:
    `error` -
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    clone of this, except with ErrorEstimates set according to values in error
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### longString

    public String longString()
                      throws VisADException,
                             RemoteException

  Returns:
    a longer String than returned by toString()
  Throws:
    `VisADException`
    `RemoteException`

### longString

    public String longString(String pre)
                      throws VisADException,
                             RemoteException

  Parameters:
    `pre` - String added to start of each line
  Returns:
    a longer String than returned by toString(), indented by pre (a string of blanks)
  Throws:
    `VisADException`
    `RemoteException`

### dataClone

    public Object dataClone()
                     throws RemoteException

  A VisAD adaptation of clone that works for local or remote Data. Catches CloneNotSupportedException and throws message in a RuntimeException.

  Returns:
    for DataImpl return clone(), and for RemoteDataImpl return clone() inherited from UnicastRemoteObject
  Throws:
    `RemoteException`